# Developer Environments

A number of development environments have been set up, adapted to different tasks.  

## General information

Please note that these instructions are for developers.  They do not necessarily explain every step in detail and have not necessarily been tested on every combination of 
hardware, operating system, software setup and so on.  You are welcome to contact us for assistance in troubleshooting problems that may arise. 

## Operating Systems

Unlike the *tutorials*, these development environments cannot be
entirely encapsulated in Docker images that can be executed on a 
wider variety of operating systems.  For almost all development 
purposes, you will also need a "real" or virtual Ubuntu Linux  
system, with ROS installed, for the actual development of your 
own software.  

Follow these installation instructions to install  
 
 - [Install Software on Local Machine or Virtual Machine](doc/install.md)
 


The development environment then provides many additional functionalities 
related to the core system, including those functionalities that are present 
in the tutorials.

## Development Environments

The basic idea is that the developer already has a Linux Ubuntu ROS installation 
and then either checks out publicly available ROS package repos or
uses Docker to get access to the software that is not publicly available.

When you have a ROS machine, follow the following instructions to set up and test basic functionality:

- [Log in to Docker Registry](https://gitlab.liu.se/lrs/devenv_docker_images) -- Just follow the instructions to log in.  Do not download the image.
- [Prepare Existing ROS Computer](doc/prepare_ros_computer.md)
- [Using a Local ROS Installation with LRS Docker Modules](doc/local_ros_installation.md)

For more information on how to integrate your code we have split the information in different sub-areas:

- [Development Environment: Gränsö](https://gitlab.liu.se/lrs/lrs_devenv_granso): Sensor simulation in Gränsö doe DJI, MQTT interface also to images
- [Development Environment: Control](https://gitlab.liu.se/lrs/lrs_devenv_control)
- [Development Environment: Motion Planning](https://gitlab.liu.se/lrs/lrs_devenv_motion_planning)
- [Development Environment: Task Planning](https://gitlab.liu.se/lrs/lrs_devenv_task_planning)

